
let dump buf =
  let i = ref 0 in
  Bytes.iter (fun c -> Printf.printf "%02x" (Char.code c); incr i; if !i land 15 = 0 then print_string "\n") buf

let unhex txt =
  let n = String.length txt / 2 in
  let buf = Bytes.create n in
  for i = 0 to n - 1 do
    Scanf.sscanf (String.sub txt (i * 2) 2) "%02x" (fun c -> Bytes.set buf i (Char.chr c))
  done;
  buf

let () =
  let dec_key = unhex Sys.argv.(1) in
  let fd = Unix.(socket PF_INET SOCK_STREAM 0) in
  Unix.(connect fd (ADDR_INET (inet_addr_of_string "127.0.0.1", 31337)));
  let sc = Scomm.prepare_channel ~dec_key ~enc:false fd in
  while let readable, _, _ = Unix.select [ fd ] [] [] 0.0 in readable = [ fd ] do
    match Scomm.recv sc with
    | None -> ()
    | Some buf ->
        Printf.printf "msg:\n%!";
        let hdr, msg = Msg.parse buf in
        Msg.print_hdr Format.std_formatter hdr;
        Msg.print Format.std_formatter msg;
        Format.fprintf Format.std_formatter "--\n";
  done

