open Printf

(* entire data section of the .wasm binary *)

let data =
  [|
  0xdc; 0x63; 0x7a; 0x21; 0x58; 0x1f; 0x76; 0x5d; 0xd4; 0xdb; 0x72; 0x99; 
  0x50; 0x97; 0x6e; 0xd5; 0xcc; 0x53; 0x6a; 0x11; 0x48; 0x0f; 0x66; 0x4d; 
  0xc4; 0xcb; 0x62; 0x89; 0x40; 0x87; 0x5e; 0xc5; 0xbc; 0x43; 0x5a; 0x01; 
  0x38; 0xff; 0x56; 0x3d; 0xb4; 0xbb; 0x52; 0x79; 0x30; 0x77; 0x4e; 0xb5; 
  0xac; 0x33; 0x4a; 0xf1; 0x28; 0xef; 0x46; 0x2d; 0xa4; 0xab; 0x42; 0x69; 
  0x20; 0x67; 0x3e; 0xa5; 0x9c; 0x23; 0x3a; 0xe1; 0x18; 0xdf; 0x36; 0x1d; 
  0x94; 0x9b; 0x32; 0x59; 0x10; 0x57; 0x2e; 0x95; 0x8c; 0x13; 0x2a; 0xd1; 
  0x08; 0xcf; 0x26; 0x0d; 0x84; 0x8b; 0x22; 0x49; 0x00; 0x47; 0x1e; 0x85; 
  0x7c; 0x03; 0x1a; 0xc1; 0xf8; 0xbf; 0x16; 0xfd; 0x74; 0x7b; 0x12; 0x39; 
  0xf0; 0x37; 0x0e; 0x75; 0x6c; 0xf3; 0x0a; 0xb1; 0xe8; 0xaf; 0x06; 0xed; 
  0x64; 0x6b; 0x02; 0x29; 0xe0; 0x27; 0xfe; 0x65; 0x5c; 0xe3; 0xfa; 0xa1; 
  0xd8; 0x9f; 0xf6; 0xdd; 0x54; 0x5b; 0xf2; 0x19; 0xd0; 0x17; 0xee; 0x55; 
  0x4c; 0xd3; 0xea; 0x91; 0xc8; 0x8f; 0xe6; 0xcd; 0x44; 0x4b; 0xe2; 0x09; 
  0xc0; 0x07; 0xde; 0x45; 0x3c; 0xc3; 0xda; 0x81; 0xb8; 0x7f; 0xd6; 0xbd; 
  0x34; 0x3b; 0xd2; 0xf9; 0xb0; 0xf7; 0xce; 0x35; 0x2c; 0xb3; 0xca; 0x71; 
  0xa8; 0x6f; 0xc6; 0xad; 0x24; 0x2b; 0xc2; 0xe9; 0xa0; 0xe7; 0xbe; 0x25; 
  0x1c; 0xa3; 0xba; 0x61; 0x98; 0x5f; 0xb6; 0x9d; 0x14; 0x1b; 0xb2; 0xd9; 
  0x90; 0xd7; 0xae; 0x15; 0x0c; 0x93; 0xaa; 0x51; 0x88; 0x4f; 0xa6; 0x8d; 
  0x04; 0x0b; 0xa2; 0xc9; 0x80; 0xc7; 0x9e; 0x05; 0xfc; 0x83; 0x9a; 0x41; 
  0x78; 0x3f; 0x96; 0x7d; 0xf4; 0xfb; 0x92; 0xb9; 0x70; 0xb7; 0x8e; 0xf5; 
  0xec; 0x73; 0x8a; 0x31; 0x68; 0x2f; 0x86; 0x6d; 0xe4; 0xeb; 0x82; 0xa9; 
  0x60; 0xa7; 0x7e; 0xe5; 0x7b; 0x20; 0x72; 0x65; 0x74; 0x75; 0x72; 0x6e; 
  0x20; 0x4d; 0x6f; 0x64; 0x75; 0x6c; 0x65; 0x2e; 0x64; 0x28; 0x24; 0x30; 
  0x29; 0x3b; 0x20; 0x7d; 0x00; 0x94; 0x20; 0x85; 0x10; 0xc2; 0xc0; 0x01; 
  0xfb; 0x01; 0xc0; 0xc2; 0x10; 0x85; 0x20; 0x94; 0x01; 0xbb; 0x6b; 0xd9; 
  0xcf; 0x25; 0x71; 0xef; 0x52; 0x52; 0xbd; 0x1b; 0xfc; 0x09; 0x6e; 0x41; 
  0xbe; 0x9b; 0x28; 0xea; 0x83; 0x5c; 0x3f; 0x08; 0x80; 0x7e; 0x13; 0xda; 
  0xfd; 0xe9; 0xd8; 0x84; 0x97; 0x93; 0xb2; 0xac; 0xc6; 0x79; 0xf1; 0x5a; 
  0x70; 0x91; 0xf2; 0xc7; 0x74; 0xb8; 0xa2; 0xf0; 0xa6; 0x2b; 0x39; 0xf2; 
  0x70; 0xc8; 0x87; 0xae; 0x96; 0xc4; 0x0f; 0xbe; 0x85; 0x2e; 0x53; 0xd0; 
  0x8d; 
  |]

let obfu byte = assert (byte >= 0 && byte <= 255); data.(byte)

let deob byte = (200 * byte * byte + 255 * byte + 92) land 255

let () =
  for i = 0 to 255 do
    assert (deob (obfu i) = i)
  done

let plaintext = Array.init 16 (fun i -> Char.code "-Fancy Nounours-".[i])

(* the password salt is at 0, the iv at 16, and first first encrypted block at 32 (see function decryptData) *)

let ciphertext =
  let ct = Bytes.create 972320 in
  let cin = open_in_bin "payload.enc" in
  really_input cin ct 0 (Bytes.length ct);
  close_in cin;
  (* replicate call to deobfuscate from decryptAndExecPayload *)
  Bytes.iteri (fun i byte -> Bytes.set ct i (Char.chr (deob (Char.code byte)))) ct;
  ct

let arr_byt bytes = Array.init (Bytes.length bytes) (fun i -> Char.code (Bytes.get bytes i))

let byt_arr a = Bytes.init (Array.length a) (fun i -> Char.chr a.(i))

let iv = Bytes.sub ciphertext 16 16

let c i = Bytes.sub ciphertext (32 + 16 * i) 16

let xor_arrays a b =
  assert (Array.length a = Array.length b);
  Array.init (Array.length a) (fun i -> a.(i) lxor b.(i))

let shift_left buf =
  assert (Array.length buf >= 16);
  let sum = ref buf.(0) in
  for a = 0 to 14 do
    buf.(a) <- buf.(a+1);
    let mask = ref 0 in
    let e = ref data.(a + 281) in
    let msg = ref buf.(a+1) in
    try
      while true do
        mask := !mask lxor (if !e land 1 = 1 then !msg else 0);
        msg := ((!msg lsl 1) lxor (if !msg land 0x80 <> 0 then 0xc3 else 0)) land 0xff;
        e := !e lsr 1;
        if !e = 0 then raise Exit
      done
    with Exit ->
    sum := !sum lxor !mask
  done;
  buf.(15) <- !sum

let phi buf =
  for i = 1 to 16 do
    shift_left buf
  done

let phi9 buf =
  for i = 1 to 0 do
    phi buf
  done

let key_mask =
  (* xor known plaintext with iv *)
  let ptiv = xor_arrays plaintext (arr_byt iv) in
  (* undo s-box of last round by applying deob to each byte of ptiv *)
  let dpt = Array.map deob ptiv in
  (* apply phi 9 times to corresponding block of ciphertext *)
  let c0 = arr_byt (c 0) in
  phi9 c0;
  (* the constant key-dependent mask is phi^9(Ci) xor deob(Pi) *)
  xor_arrays c0 dpt

let p i =
  let ci = arr_byt (c i) in
  phi9 ci;
  let ptx = Array.map obfu (xor_arrays ci key_mask) in
  (* undo CBC mode *)
  xor_arrays (arr_byt (c (i - 1))) ptx

let () =
  let cout = open_out_bin "payload.dec" in
  for i = 1 to (Bytes.length ciphertext) / 16 - 2 do
    output_bytes cout (byt_arr (p i))
  done;
  close_out cout

(* SSTIC2018{f2ff2a7ed70d4ab72c52948be06fee20} *)

